# Diapositiva: Conjunto de datos para trabajar
medida <- c( 3, 1, 2, 3, 1, 6, 2, 4, 1, 2, 6, 5, 1, 3, 5, 4, 2, 3, 4, 5 )
grupo  <- c( 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 )
df     <- data.frame( grupo, medida )
head( df )
str(df)
df$grupo <- factor(df$grupo)
str(df)

#_t_-test dependiente (_paired_)
df$medida[ df$grupo == 0 ]
shapiro.test( df$medida[ df$grupo == 0 ]
)
shapiro.test( df$medida[ df$grupo == 1 ]
 )

# _t_-test dependiente. Hipótesis a contrastar

?t.test
fitDep <- t.test( df[ df$grupo == 1, 2 ], df[ df$grupo == 0, 2 ], 
                  alternative= "two.sided", conf.level = 0.95, 
                  paired = TRUE )
fitDep

t.test( df[ df$grupo == 1, 2 ], df[ df$grupo == 0, 2 ], 
        alternative= "greater", paired = TRUE )
t.test( df[ df$grupo == 1, 2 ], df[ df$grupo == 0, 2 ], 
        alternative= "less", paired = TRUE )

### _t_-test independiente (_unpaired_)
var.test( df[ df$grupo == 0, 2 ], df[ df$grupo == 1, 2 ] )

fitIndep <- t.test( df[ df$grupo == 1, 2 ], df[ df$grupo == 0, 2 ], 
                    alternative= "two.sided", conf.level = 0.95, 
                    paired = FALSE, var.equal = TRUE)

fitIndep
### _t_-test para una muestra
shapiro.test( df$medida )

### _t_-test para una muestra. Hipótesis a contrastar
t.test( df[ , 2 ], mu = 3, conf.level = 0.95 )

### Tamaño del efecto de un t-test
s <- sd(   df[ df$grupo == 1, 2 ] - df[ df$grupo == 0, 2 ] )
M <- mean( df[ df$grupo == 1, 2 ] - df[ df$grupo == 0, 2 ] )
d <- abs( M ) / s
d

library("MBESS")
ci.sm( Mean = M, SD = s, N = 10, conf.level = 0.95 )

### Tamaño del efecto de un t-test independiente

library( compute.es )
tes( fitIndep[[1]], 10, 10 )


### Ejercicio
autoestima <-c(8, 7, 6, 8, 7, 5, 6, 4, 9, 9, 8, 6, 5, 6, 5, 4, 4, 5, 6, 4)
grupo<-c( rep("CAMPO",10), rep("CIUDAD",10))
df <-data.frame( grupo, autoestima )
head( df )
boxplot( autoestima~grupo , data=df , col= "pink")


### Conjunto de datos para trabajar
df <- read.table( "files/ejemplo.csv", sep = ";",
                  head = TRUE )
head(df)

df$raza   <- factor( df$raza )
df$genero <- factor( df$genero )
length(df$m0[df$raza ==3])

### Anova de 1 vía
fit2 <- bartlett.test( df$m0 ~ df$raza )
fit2
fit4 <- shapiro.test( df$m0 )
fit4
fit1E <- aov( m0 ~ raza, data=df )
summary( fit1E )

### Anova de 1 vía A MANO
m1 <- mean(df$m0[df$raza==1]) 
m2 <- mean(df$m0[df$raza==2])
m3 <- mean(df$m0[df$raza==3])
gmean <- mean(df$m0)
est1 <- gmean - m1
est2 <- gmean - m2
est3 <- gmean - m3
#suma de cuadrados entre los grupos:
#(Compara cada grupo con la media total)
SSE <- 6*(est1^2+est2^2+est3^2)
#suma de cuadrados dentro de los grupos
#(Compara cada elemento del grupo con la media del grupo)
SSI <- sum((df$m0[df$raza==1]-m1)^2)+
sum((df$m0[df$raza==2]-m2)^2)+
sum((df$m0[df$raza==3]-m3)^2)
#grados de libertad:
dfrazas <- 3 - 1
dftotal <- 18-1
dfresi <- dftotal-dfrazas

# Cuando no hay homocedasticidad...test de Welch
oneway.test( m0 ~ raza, data=df )

# Tamaño del efecto
fit1E <- aov( m0 ~ raza, data=df )


# Contrastes _post hoc_. Menos de 6 niveles. Bonferroni

pairwise.t.test(df$m0, df$raza, p.adj = "bonferroni")
pairwise.t.test(df$m0, df$raza, p.adj = "holm")

# Contrastes _post hoc_. Más de 6 niveles
pairwise.t.test(df$m0, df$raza, p.adj = "none")
fit1E <- aov( m0 ~ raza, data = df )
TukeyHSD( fit1E )

#Comparaciones planificadas. Código
mat <- c( -2, 1, 1 )
contrasts( df$raza ) <- mat
fit<-aov( m0 ~ raza, data = df)
summary( fit11, split=list( raza = list( "C1" = 1) ) )

### ANOVA de dos vías
fit6 <- bartlett.test( df$m0 ~ df$genero )
fit2E <- aov( m0 ~ raza * genero, data = df )
summary(fit2E)

### ANOVA de dos vías. Otros posibles iteration plots

par(mfrow = c(3,1))
demo1 <- read.table( "files/ejemplo1.csv", sep = ";",
                     head = TRUE )


  demo1$grupo <- factor(demo1$grupo)
  demo1$tiempo <- factor(demo1$tiempo)
  demo1$id <- factor(demo1$id)


interaction.plot(demo1$tiempo, demo1$grupo, demo1$pulso,                            
                             ylim = c(5, 20),col = c("orange", "blue" ),  lty= c(1, 12), lwd = 3,
                             ylab = "nedia", xlab = "raza", trace.label = "grupo")

fit <- aov(pulso ~ grupo*tiempo, data=demo1)
summary(fit)
demo3 <- read.table( "files/ejemplo3.csv", sep = ";",
                     head = TRUE )

demo3 <- within(demo3, {
  grupo <- factor(grupo)
  tiempo <- factor(tiempo)
  id <- factor(id)
})

with(demo3, interaction.plot(tiempo, grupo, pulso,
                             ylim = c(10, 60), col = c("orange", "blue" ), lty = c(1, 12), lwd = 3,
                             ylab = "nedia", xlab = "raza", trace.label = "grupo"))

demo4 <- read.table( "files/ejemplo4.csv", sep = ";",
                     head = TRUE )


demo4 <- within(demo4, {
  grupo <- factor(grupo)
  tiempo <- factor(tiempo)
  id <- factor(id)
})
par(cex = .6)

with(demo4, interaction.plot(tiempo, grupo, pulso,
                             ylim = c(10, 60),col = c("orange", "blue" ),  lty = c(1, 12), lwd = 3,
                             ylab = "nedia", xlab = "raza", trace.label = "grupo"))




# ANOVA de dos vías. EL orden importa
fit2E <- aov( m0 ~ raza * genero, data = df )
summary(fit2E)
fit2E2 <- aov( m0 ~ genero * raza, data = df )
summary(fit2E2)
dfMOD <- df[ 1:9, ]
dfMOD
fit2E3 <- aov( m0 ~ raza * genero, data = dfMOD )
summary( fit2E3 ) 
fit2E4 <- aov( m0 ~ genero * raza, data = dfMOD )
summary( fit2E4 ) 


# ANOVA de dos vías. Datos no balanceados

fit2E5 <- lm( m0 ~ genero * raza, data = df )
library( "car" )
Anova( fit2E5, type = "III" )


